/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <X11/Xlib.h>

#define ARC 10
#define X 20
#define Y 20
static GC gc;
static unsigned int width, height;
static unsigned int rw = 0, rh = 0;
static int px, py;

/* EBhẼTCY𒲂ׂĐ}`̈ʒuƃTCYČvZ */
static void ResetSizeAndPos(event)
    XEvent event;
{
    unsigned int old_w, old_h;
    old_w = rw;
    old_h = rh;
    width = event.xconfigure.width;
    height = event.xconfigure.height;

    /* `̃TCYČvZ */
    rw = width - X * 2;
    rh = height - Y * 2;

    /* ~̈ʒuČvZ */
    if (old_w == 0) px = width / 2;
    else            px = (double)(px - X) * (double)rw / (double)old_w + X;
    if (old_h == 0) py = height / 2;
    else            py = (double)(py - Y) * (double)rh / (double)old_h + Y;
}

/* EBhEɐ}`` */
static void Redraw(display, window)
    Display *display;
    Window window;
{
    XDrawRectangle(display, window, gc, X, Y, rw, rh);
    XFillArc(display, window, gc, px - ARC/2, py - ARC/2, ARC, ARC,
             0, 360*64);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    Display *display;
    Window window;

    /* (1) fBXvCI[v */
    display = XOpenDisplay(NULL);

    /* (2) EBhE쐬ă}bv */
    window = XCreateSimpleWindow(display, RootWindow(display, 0),
                                400, 400, 200, 200, 0,
                                BlackPixel(display, 0), WhitePixel(display, 0));
    XMapWindow(display, window);

    /* (3) Cxg̏ (CxgE}XN̐ݒ) */
    XSelectInput(display, window,
                 StructureNotifyMask | ExposureMask | ButtonPressMask);

    /* (4) OtBbNEReLXg쐬ݒ */
    gc = XCreateGC(display, window, NULL, NULL);
    XSetLineAttributes(display, gc, 2, LineSolid, CapButt, JoinMiter);

    while (True) {
        XEvent event;
        XNextEvent(display, &event);

        /* (5) CxgƂɕ`揈 */
        switch (event.type) {
        case ConfigureNotify:
            ResetSizeAndPos(event);
            XClearWindow(display, window);
            Redraw(display, window);
        case Expose:
            Redraw(display, window);
            break;
        case ButtonPress:
            px = event.xbutton.x;
            py = event.xbutton.y;
            XClearWindow(display, window);
            Redraw(display, window);
            break;
        }
    }
}
