/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

typedef struct {  /* \[Xli[\̂̒` */
    int    num_labels;
} CustomRec, *CustomPtr;

static XtResource res[] = {  /* \[X`\̂̔z */
  {"numLabels", "NumLabels", XtRInt,
   sizeof(int), XtOffsetOf(CustomRec, num_labels),
   XtRImmediate, (XtPointer) 2},
};

static Widget CreateScaleWithMarks(parent, name)
    Widget parent;
    String name;
{
    Widget scale, label;
    CustomRec data;  /* \[Xli[\̂p */
    char mark[20];
    int i, min, max;

    scale = XmCreateScale(parent, name, NULL, 0); /* XP[쐬 */
    XtVaGetValues(scale, XmNminimum, &min, /* XP[̍őEŏl𒲂ׂ */
                         XmNmaximum, &max, NULL);
    /* XP[p̓Ǝ\[X擾 */
    XtGetApplicationResources(scale, &data, res, XtNumber(res), NULL, 0);
    /* w肳ꂽ̖ڐXP[ɕt */
    for (i = 0; i < data.num_labels; i++) {
        sprintf(mark, "%d", min + i * (max - min) / (data.num_labels - 1));
        label = XmCreateLabelGadget(scale, mark, NULL, 0);
        XtManageChild(label);
    }
    return scale;
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, scale1, scale2;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0; /* \[XEf[^x[X */
    toplevel = XtAppInitialize(&app_context, "Scales", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ڐt̃XP[Q쐬 */
    scale1 = CreateScaleWithMarks(panel, "scale1");
    XtManageChild(scale1);
    scale2 = CreateScaleWithMarks(panel, "scale2");
    XtManageChild(scale2);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
