/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void PasteCB();
static Boolean ConvertProc();
static void LoseProc();
static void GetValueProc();

static Widget box, figure, title;
static Boolean owner = False;
static Atom xa_figure, xa_title;
static Pixmap pixmap;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Select2type", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (1) Gƃx͂ޔ */
    ac = 0;
    box = XmCreateRowColumn(panel, "box", al, ac);
    XtManageChild(box);
    /* G */
    ac = 0;
    figure = XmCreateLabel(box, "figure", al, ac);
    XtManageChild(figure);
    /* x */
    ac = 0;
    title = XmCreateLabel(box, "title", al, ac);
    XtManageChild(title);

    /* [Rs[] {^ --> L: ZNVL */
    ac = 0;
    copy = XmCreatePushButton(panel, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);

    /* [y[Xg] {^ --> v: ZNVEf[^v */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    /* (2) "_FIGURE"  "_TITLE" ̃Ag𐶐Ă */
    xa_figure = XmInternAtom(XtDisplay(toplevel), "_FIGURE", False);
    xa_title = XmInternAtom(XtDisplay(toplevel), "_TITLE", False);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* L: [Rs[] {^̃R[obN */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Pixel fg, bg;

    if (owner)    /* łɎL҂ɂȂĂ΁CȂ */
        return;

    /* (3) ZNVL (3̃R[obNo^) */
    if (XtOwnSelection(box, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(box)),
                       ConvertProc, LoseProc, NULL)) {
        /* LłCGƃx𔽓]\Ēm点 */
        XtVaGetValues(figure, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(figure, XmNforeground, bg, XmNbackground, fg, NULL);
        XtVaGetValues(title, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(title, XmNforeground, bg, XmNbackground, fg, NULL);
        owner = True;
    }
}

/* L: ZNV̏LƂɌĂяo */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    Pixel fg, bg;

    /* (4) ZNV̏L҂łȂȂC\ */
    if (*selection == XA_PRIMARY) {
        XtVaGetValues(figure, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(figure, XmNforeground, bg, XmNbackground, fg, NULL);
        XtVaGetValues(title, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(title, XmNforeground, bg, XmNbackground, fg, NULL);
        owner = False;
    }
}

/* v: [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Atom atoms[2];

    /* (5) ZNṼf[^v (xƊG̗𓯎ɗv) */
    atoms[0] = xa_figure;
    atoms[1] = xa_title;
    XtGetSelectionValues(box, XA_PRIMARY, atoms, 2, GetValueProc, NULL,
                         XtLastTimestampProcessed(XtDisplay(box)));
}

/* L: ZNṼf[^vꂽƂɌĂяo */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    if (*selection != XA_PRIMARY)  /* ̂ "PRIMARY" ZNV̂ */
        return False;

    /* vꂽ^[Qbg̃f[^pӂĕԂ */
    if (*target == xa_figure) {
        /* (6) ṽ^[Qbg "_FIGURE" ȂCfigure ̊G] */
        /* figure G (sbNX}bv) o */
        XtVaGetValues(figure, XmNlabelPixmap, &pixmap, NULL);
        /* ̃sbNX}bv ID ] */
        *val_ret = &pixmap;
        *len_ret = 1;
        *type_ret = XA_PIXMAP;  /* ^Cv̓sbNX}bv */
        *format_ret = 32;       /* sbNX}bṽtH[}bg 32 */
        return True;   /* ]f[^̏ɐƂ} */
    }
    else if (*target == xa_title) {
        /* (7) ṽ^[Qbg "_TITLE" ȂCtitle ̕] */
        XmString string;
        char *text;
        /* title 烉xo */
        XtVaGetValues(title, XmNlabelString, &string, NULL);
        /* RpEhEXgO畁ʂ̕o */
        XmStringGetLtoR(string, XmFONTLIST_DEFAULT_TAG, &text);
        XmStringFree(string);
        /* ̕] */
        *val_ret = text;
        *len_ret = strlen(text) + 1;  /* Ō NULL ǉ */
        *type_ret = XA_STRING;        /* ̗͉p̃eLXĝ݈ */
        *format_ret = 8;              /* ̃tH[}bg 8 */
        return True;   /* ]f[^̏ɐƂ} */
    }
    else
        return False;  /* mȂ^Cv */
}

/* v: ZNṼf[^󂯎ƂɌĂяo */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    if (*len == 0 || val == NULL) { /* f[^̎󂯎Ɏs */
        XBell(XtDisplay(w), 0);  /* xŎs̍} */
        return;
    }

    if (*selection != XA_PRIMARY) { /* ̂ "PRIMARY" ZNV̂ */
        XBell(XtDisplay(w), 0);  /* xŎs̍} */
        return;
    }

    /* 󂯎f[^E^Cvɍ{ */
    if (*type == XA_PIXMAP) {
        /* (8) "PIXMAP" ^CvȂCfigure ɊG (sbNX}bv) \ */
        XtVaSetValues(figure, XmNlabelPixmap, *(Pixmap*)val, NULL);
    }
    else if (*type == XA_STRING) {
        /* (9) "STRING" ^CvȂCtitle ɕ\ */
        XmString string;
        string = XmStringCreateLocalized((char *)val);
        XtVaSetValues(title, XmNlabelString, string, NULL);
        XmStringFree(string);
    }
    else
        XBell(XtDisplay(w), 0);  /* ^CvႤƃxŎs̍} */

    XtFree((char *)val);
}
